searchNodes=[{"doc":"WORK IN PROGRESS, DO NOT USE / ˈin ( t ) ərˌnet jo͞os / noun : internet juice SEO (Search Engine Optimization) provides a framework for Phoenix applications to more-easily optimize your site for search engines and displaying rich results when your URLs are shared across the internet. The better visibility your pages have in search results, the more likely you are to have visitors. Installation def deps do [ { :phoenix_seo , &quot;~&gt; 0.1.2&quot; } ] end Usage Define an SEO module for your web application and defaults defmodule MyAppWeb.SEO do use SEO , [ json_library : Jason , site : SEO.Site . build ( default_title : &quot;Default Title&quot; , description : &quot;A blog about development&quot; , title_suffix : &quot; · My App&quot; ) , open_graph : SEO.OpenGraph . build ( description : &quot;A blog about development&quot; , site_name : &quot;My Blog&quot; , type : :website , locale : &quot;en_US&quot; ) , twitter : SEO.Twitter . build ( site : &quot;@example&quot; , site_id : &quot;27704724&quot; , creator : &quot;@example&quot; , creator_id : &quot;27704724&quot; , card : :summary ) ] end Implement functions to build SEO information about your entities defmodule MyApp.Article do # This might be an Ecto schema or a plain struct defstruct [ :id , :title , :description , :author , :reading , :published_at ] end defimpl SEO.OpenGraph.Build , for : MyApp.Article do alias MyAppWeb.Router.Helpers , as : Routes @endpoint MyAppWeb.Endpoint def build ( article ) do SEO.OpenGraph . build ( type : :article , type_detail : SEO.OpenGraph.Article . build ( published_time : article . published_at |&gt; DateTime . to_date ( ) |&gt; Date . to_iso8601 ( ) , author : article . author , section : &quot;Tech&quot; ) , image : image ( article ) , title : article . title , description : article . description ) end defp image ( article ) do file = &quot;/images/article/ \#{ article . id } .png&quot; exists? = [ Application . app_dir ( :my_app ) , &quot;/priv/static&quot; , file ] |&gt; Path . join ( ) |&gt; File . exists? ( ) if exists? do SEO.OpenGraph.Image . build ( url : Routes . static_url ( @endpoint , file ) , secure_url : Routes . static_url ( @endpoint , file ) , alt : article . title ) end end end defimpl SEO.Site.Build , for : MyApp.Article do alias MyAppWeb.Router.Helpers , as : Routes @endpoint MyAppWeb.Endpoint def build ( article ) do SEO.Site . build ( url : Routes . article_url ( @endpoint , :show , article . id ) , title : article . title , description : article . description ) end end defimpl SEO.Facebook.Build , for : MyApp.Article do def build ( _article ) do SEO.Facebook . build ( app_id : &quot;123&quot; ) end end defimpl SEO.Twitter.Build , for : MyApp.Article do def build ( article ) do SEO.Twitter . build ( description : article . description , title : article . title ) end end defimpl SEO.Unfurl.Build , for : MyApp.Article do def build ( article ) do SEO.Unfurl . build ( label1 : &quot;Reading Time&quot; , data1 : &quot;5 minutes&quot; , label2 : &quot;Published&quot; , data2 : DateTime . to_iso8601 ( article . published_at ) ) end end defimpl SEO.Breadcrumb.Build , for : MyApp.Article do alias MyAppWeb.Router.Helpers , as : Routes @endpoint MyAppWeb.Endpoint def build ( article ) do SEO.Breadcrumb.List . build ( [ % { name : &quot;Articles&quot; , item : Routes . article_url ( @endpoint , :index ) , % { name : article . title , item : Routes . article_url ( @endpoint , :show , article . id ) ] ) end end Assign the item to your conns and/or sockets # In a plain Phoenix Controller def show ( conn , params ) do article = load_article ( params ) conn |&gt; SEO . assign ( article ) |&gt; render ( &quot;show.html&quot; ) end def index ( conn , params ) do conn |&gt; SEO . assign ( %{ title : &quot;Listing Best Hugs&quot; } ) |&gt; render ( &quot;show.html&quot; ) end # In a Phoenix LiveView, make sure you handle with # mount/3 or handle_params/3 so it&#39;s present on # first static render. def mount ( _params , _session , socket ) do # You may mark it as temporary since it&#39;s only needed on the first render. { :ok , socket , temporary_assigns : [ SEO . key ( ) ] } end def handle_params ( params , _uri , socket ) do { :noreply , SEO . assign ( socket , load_article ( params ) ) } end Juice up your root layout: &lt; head &gt; &lt;%# remove the Phoenix-generated &lt;.live_title&gt; component %&gt; &lt;%# and replace with SEO.juice component %&gt; &lt; SEO.juice config = { MyAppWeb.SEO . config ( ) } item = { SEO . item ( assigns ) } page_title = { assigns [ :page_title ] } /&gt; &lt;/ head &gt; Alternatively, you may selectively render components. For example: &lt; head &gt; &lt;%# With your SEO module&#39;s configuration %&gt; &lt; SEO.OpenGraph.meta config = { MyAppWeb.SEO . config ( :open_graph ) } item = { SEO.OpenGraph.Build . build ( SEO . item ( assigns ) ) } /&gt; &lt;%# Or with some other default configuration %&gt; &lt; SEO.OpenGraph.meta config = { [ default_title : &quot;Foo Fighters&quot; ] } item = { SEO.OpenGraph.Build . build ( SEO . item ( assigns ) ) } /&gt; &lt;%# Or without defaults %&gt; &lt; SEO.OpenGraph.meta item = { SEO.OpenGraph.Build . build ( SEO . item ( assigns ) ) } /&gt; &lt;/ head &gt;","ref":"SEO.html","title":"SEO","type":"module"},{"doc":"Setup your defaults. Domains are mapped this way: :site -&gt; SEO.Site :open_graph -&gt; SEO.OpenGraph :unfurl -&gt; SEO.Unfurl :facebook -&gt; SEO.Facebook :twitter -&gt; SEO.Twitter :breadcrumb -&gt; SEO.Breadcrumb For example: use SEO , [ site : SEO.Site . build ( description : &quot;My Blog of many words and infrequent posts&quot; , default_title : &quot;Fanastic Site&quot; ) facebook : SEO.Facebook . build ( app_id : &quot;123&quot; ) ]","ref":"SEO.html#__using__/1","title":"SEO.__using__/1","type":"macro"},{"doc":"Assign the SEO item from the Plug.Conn or LiveView Socket","ref":"SEO.html#assign/2","title":"SEO.assign/2","type":"function"},{"doc":"Fetch the SEO item from the Plug.Conn or LiveView Socket","ref":"SEO.html#item/1","title":"SEO.item/1","type":"function"},{"doc":"Provide SEO juice. Requires an item and passes the item through all available domains &lt; head &gt; &lt;%# remove the Phoenix-generated &lt;.live_title&gt; component %&gt; &lt;%# and replace with SEO.juice component %&gt; &lt; SEO.juice config = { MyAppWeb.SEO . config ( ) } item = { SEO . item ( assigns ) } page_title = { assigns [ :page_title ] } /&gt; &lt;/ head &gt; Alternatively, you may selectively render components: &lt; head &gt; &lt;%# With your SEO module&#39;s configuration %&gt; &lt; SEO.OpenGraph.meta config = { MyAppWeb.SEO . config ( :open_graph ) } item = { SEO.OpenGraph.Build . build ( SEO . item ( assigns ) ) } /&gt; &lt;%# Or with runtime configuration %&gt; &lt; SEO.Twitter.meta config = { %{ site_name : &quot;Foo Fighters&quot; } } item = { SEO.Twitter.Build . build ( SEO . item ( assigns ) ) } /&gt; &lt;%# Or without configuration is fine too %&gt; &lt; SEO.Unfurl.meta item = { SEO.Unfurl.Build . build ( SEO . item ( assigns ) ) } /&gt; &lt;/ head &gt; Attributes item ( :any ) (required) - Item to render that implements SEO.Build . page_title ( :string ) - Page Title. Overrides item's title if supplied. Defaults to nil . config ( :any ) - Configuration for your SEO module. Defaults to nil .","ref":"SEO.html#juice/1","title":"SEO.juice/1","type":"function"},{"doc":"","ref":"SEO.html#key/0","title":"SEO.key/0","type":"function"},{"doc":"This is SEO for Google to display breadcrumbs in the search results. This allows the search result to search as multiple links. Resources https://developers.google.com/search/docs/data-types/breadcrumbs https://json-ld.org/ https://search.google.com/test/rich-results https://search.google.com/structured-data/testing-tool Rendered example inside a &lt;script type=&quot;application/ld+json&quot;&gt; : { &quot;@context&quot;: &quot;https://schema.org&quot;, &quot;@type&quot;: &quot;BreadcrumbList&quot;, &quot;itemListElement&quot;: [{ &quot;@type&quot;: &quot;ListItem&quot;, &quot;item&quot;: &quot;https://bernheisel.com/blog&quot;, &quot;name&quot;: &quot;Posts&quot;, &quot;position&quot;: 1 },{ &quot;@type&quot;: &quot;ListItem&quot;, &quot;item&quot;: &quot;https://bernheisel.com/blog/nostalgia-programming&quot;, &quot;name&quot;: &quot;Nostalgia, Fun, and Programming&quot;, &quot;position&quot;: 2 }] }","ref":"SEO.Breadcrumb.html","title":"SEO.Breadcrumb","type":"module"},{"doc":"Attributes item ( SEO.Breadcrumb.List ) json_library ( :atom ) (required) config ( :any ) - Defaults to nil .","ref":"SEO.Breadcrumb.html#meta/1","title":"SEO.Breadcrumb.meta/1","type":"function"},{"doc":"Facebook originally developed the OpenGraph standard, so much of social-sharing techniques are contained in SEO.OpenGraph , however there remains one Facebook-specific attribute: the :app_id . Resources: https://developers.facebook.com/docs/sharing/webmaster","ref":"SEO.Facebook.html","title":"SEO.Facebook","type":"module"},{"doc":"In order to use Facebook Insights you must add the :app_id to your page. Insights lets you view analytics for traffic to your site from Facebook. Find the app ID in your Facebook App Dashboard.","ref":"SEO.Facebook.html#build/2","title":"SEO.Facebook.build/2","type":"function"},{"doc":"Attributes item ( SEO.Facebook ) - Defaults to nil . config ( :any ) - Defaults to nil .","ref":"SEO.Facebook.html#meta/1","title":"SEO.Facebook.meta/1","type":"function"},{"doc":"","ref":"SEO.Facebook.html#t:t/0","title":"SEO.Facebook.t/0","type":"type"},{"doc":"Build OpenGraph tags. This is consumed by platforms such as Google, Facebook, Twitter, Slack, and others. For example, the following is the OpenGraph markup for the movie &quot;The Rock&quot; on IMDB: &lt; html &gt; &lt; head &gt; &lt; title &gt; The Rock (1996) &lt;/ title &gt; &lt; meta property = &quot;og:title&quot; content = &quot;The Rock&quot; /&gt; &lt; meta property = &quot;og:type&quot; content = &quot;video.movie&quot; /&gt; &lt; meta property = &quot;og:url&quot; content = &quot;https://www.imdb.com/title/tt0117500/&quot; /&gt; &lt; meta property = &quot;og:image&quot; content = &quot;https://ia.media-imdb.com/images/rock.jpg&quot; /&gt; ... &lt;/ head &gt; ... &lt;/ html &gt; Resources https://developers.google.com/search/docs/appearance/structured-data/intro-structured-data https://developers.facebook.com/docs/sharing/webmasters/ https://developer.twitter.com/en/docs/tweets/optimize-with-cards/overview/markup https://developer.twitter.com/en/docs/tweets/optimize-with-cards/overview/abouts-cards","ref":"SEO.OpenGraph.html","title":"SEO.OpenGraph","type":"module"},{"doc":"Represent your items on the graph of the internet. 🤩🌐📄 Basic Metadata The four required properties for every page are: :title - The title of your item as it should appear within the graph, e.g., &quot;The Rock&quot;. :type - The type of your item, e.g., :article . Depending on the type you specify, other properties may also be required. Default is :website . :image - An image URL or SEO.OpenGraph.Image that represents your item within the graph. :url - The canonical URL of your item that will be used as its permanent ID in the graph, e.g., &quot; https://www.imdb.com/title/tt0117500/&quot; . Ultimately, this is where the programs will scrape for metadata. For example, if you use a url of a YouTube video page, the scraper will use the OpenGraph tags found on that video page and not the currently-visited site. Optional Metadata The following properties are optional for any item and are generally recommended: :audio - A URL to a complementing audio file. You may also be more detail with SEO.OpenGraph.Audio :description - A one to two sentence description of your item. :determiner - The word that appears before this item's title in a sentence. An enum of :a , :an , :the , nil , :auto . If :auto is chosen, the consumer of your data should chose between :a or :an . :locale - The locale these tags are marked up in. Of the format language_TERRITORY. Unsupplied is consumed as &quot;en_US&quot; . :locale_alternate - A list of other locales this page is available in and their URLs. :site_name - If your item is part of a larger web site, the name which should be displayed for the overall site. e.g., &quot;IMDb&quot;. :video - A URL to a complementing video file. You may also provide more detail with SEO.OpenGraph.Video","ref":"SEO.OpenGraph.html#build/2","title":"SEO.OpenGraph.build/2","type":"function"},{"doc":"Attributes item ( SEO.OpenGraph ) - Defaults to nil . config ( :any ) - Defaults to nil .","ref":"SEO.OpenGraph.html#meta/1","title":"SEO.OpenGraph.meta/1","type":"function"},{"doc":"language code and territory code, eg: en_US","ref":"SEO.OpenGraph.html#t:language_territory/0","title":"SEO.OpenGraph.language_territory/0","type":"type"},{"doc":"The word that appears before this item's title in a sentence. If :auto is chosen, the consumer of your data should chose between &quot;a&quot; or &quot;an&quot;.","ref":"SEO.OpenGraph.html#t:open_graph_determiner/0","title":"SEO.OpenGraph.open_graph_determiner/0","type":"type"},{"doc":"The type of OpenGraph object.","ref":"SEO.OpenGraph.html#t:open_graph_type/0","title":"SEO.OpenGraph.open_graph_type/0","type":"type"},{"doc":"","ref":"SEO.OpenGraph.html#t:t/0","title":"SEO.OpenGraph.t/0","type":"type"},{"doc":"","ref":"SEO.OpenGraph.html#t:type_detail/0","title":"SEO.OpenGraph.type_detail/0","type":"type"},{"doc":"Metadata about your site. Example: Mask Icon: Theme Color: Resources https://developer.mozilla.org/en-US/docs/Learn/HTML/Introduction_to_HTML/The_head_metadata_in_HTML https://www.bing.com/webmasters/help/which-robots-metatags-does-bing-support-5198d240 https://developers.google.com/search/docs/crawling-indexing/consolidate-duplicate-urls https://developers.google.com/search/docs/crawling-indexing/robots-meta-tag https://developers.google.com/search/docs/crawling-indexing/special-tags https://developers.google.com/search/docs/appearance/title-link https://realfavicongenerator.net/ https://developer.apple.com/library/archive/documentation/AppleApplications/Reference/SafariWebContent/pinnedTabs/pinnedTabs.html https://www.w3.org/TR/appmanifest/#using-a-link-element-to-link-to-a-manifest","ref":"SEO.Site.html","title":"SEO.Site","type":"module"},{"doc":"Metadata that describes the site generally. :title - Title of the page. If :page_title is provided to the component, that will always win. :default_title - Fallback title when :title and :page_title is nil. :description - A one to two sentence description of your item. :canonical_url - A URL that is most representative of your item. :rating - &quot;adult&quot; . If a rating of &quot;adult&quot; is applied, it's also recommended to separate adult assets into a folder such as example.com/explicit/wow.jpg . No value provided means the content is appropriate for everyone. :alternate_languages - If your site is multilingual, you can inform search engines. Supply a list of tuples of the lang_code and the URL for the page. For example: [ { &quot;en_US&quot; , Routes . article_url ( @endpoint , article . id ) } , { &quot;ja_JP&quot; , Routes . jp_article_url ( @endpoint , article . id ) } ] :google - Google-specific metadata. It can be one of these values or a list of these values: &quot;nositelinkssearch&quot; . When users search for your site, Google Search results sometimes display a search box specific to your site, along with other direct links to your site. This tag tells Google not to show the sitelinks search box. Learn more about sitelinks search box. &quot;nopagereadaloud&quot; - Prevents various Google text-to-speech services from reading aloud web pages using text-to-speech (TTS). Prevents various :googlebot - Google crawler bot metadata. &quot;notranslate&quot; - when Google recognizes that the contents of a page aren't in the language that the user likely wants to read, Google may provide a translated title link and snippet in search results. If the user clicks the translated title link, all further user interaction with the page is through Google Translate, which will automatically translate any links followed. In general, this gives you the chance to provide your unique and compelling content to a much larger group of users. However, there may be situations where this is not desired. This meta tag tells Google that you don't want Google to provide a translation for this page. :google_site_verification - You can use this tag on the top-level page of your site to verify ownership for Search Console. Please note that while the values of the name and content attributes must match exactly what is provided to you (including upper and lower case), it doesn't matter if you change the tag from XHTML to HTML or if the format of the tag matches the format of your page. :robots - Robot instructions. You may provide or a list of the values: &quot;noindex&quot; do not index the page &quot;noimageindex&quot; do not index images on this page. If you don't specify this value, images on the page may be indexed and shown in search results. unavailable_after: [date/time] do not show this page in search results after the specified date/time. The date/time must be specified in a widely adopted format including ISO 8601. &quot;nofollow&quot; do not follow outlines from the page. &quot;none&quot; Equivalent to noindex, nofollow &quot;all&quot; There are no restrictions for indexing or serving. This directive is the default value and has no effect if explicitly listed. &quot;indexifembedded&quot; Google is allowed to index the content of a page if it's embedded in another page through iframes or similar HTML tags, in spite of a noindex directive. &quot;notranslate&quot; don't offer translation of this page in search results &quot;noarchive&quot; do not store a cached page &quot;nocache&quot; do not store a cached page. Same as &quot;noarchive&quot; &quot;noodp&quot; do not use a description from Open Directory Project &quot;nosnippet&quot; do not show a description nor a preview thumbnail for the page &quot;max-snippet:[number]&quot; max text length in characters to show in search results. The number may be: 0 no text snippet -1 no limit &quot;max-image-preview:[value]&quot; Max size of an image preview. The value may be: none do not show an image preview standard show a standard size image large show a large size image any other value will mean there is no image size limit &quot;max-video-preview:[number]&quot; Max number of seconds of a video preview. The number may be: 0 show a static image instead -1 allow any preview length :windows_tile_color - The color of the tile behind your icon when rendered on the Microsoft Windows start menu. Accepts a CSS color value, such as a hex or name. :theme_color - The chrome of the browser may use the theme color. Accepts a CSS color value. It creates a nice effect if this is set to the same color as the page's background. :mask_icon_url - URL of the mask SVG icon. Accepts an %URI{} or a string. This is used by Safari when the page is pinned to a tab. The SVG file must use 100% black for all vectors with a transparent background, a single layer, and the viewBox attribute must be set to &quot;0 0 16 16&quot; . :mask_icon_color - Safari will use the :mask_icon_url as the icon when pinned, and you may colorize the icon with a CSS color value.","ref":"SEO.Site.html#build/2","title":"SEO.Site.build/2","type":"function"},{"doc":"Attributes item ( :any ) - Defaults to nil . page_title ( :string ) - Defaults to nil . config ( :any ) - Defaults to nil .","ref":"SEO.Site.html#meta/1","title":"SEO.Site.meta/1","type":"function"},{"doc":"CSS color value. For example, &quot;#663399&quot;, &quot;red&quot;, &quot;rgb(0, 1, 3)&quot;. https://www.w3.org/TR/css-color-3/","ref":"SEO.Site.html#t:css_color/0","title":"SEO.Site.css_color/0","type":"type"},{"doc":"","ref":"SEO.Site.html#t:t/0","title":"SEO.Site.t/0","type":"type"},{"doc":"With Twitter Cards, you can attach rich photos, videos and media experiences to Tweets, helping to drive traffic to your website. Users who Tweet links to your content will have a &quot;Card&quot; added to the Tweet that's visible to their followers. Examples Summary card with large image: Player card: Resources https://developer.twitter.com/en/docs/twitter-for-websites/cards/guides/getting-started","ref":"SEO.Twitter.html","title":"SEO.Twitter","type":"module"},{"doc":"Build tags that customize how Twitter displays your page. :card - The different :card types each have a beautiful consumption experience built for Twitter’s web and mobile clients. :summary : Title, description, and thumbnail. :summary_large_image : Similar to the Summary Card, but with a prominently-featured image. :app : A Card with a direct download to a mobile app. :player : A Card that can display video/audio/media. :site - The Twitter @username the card should be attributed to :title - A concise title for the related content. :description - A description that concisely summarizes the content as appropriate for presentation within a Tweet. :image - A URL to a unique image representing the content of the page. You should not use a generic image such as your website logo, author photo, or other image that spans multiple pages. Images for this Card support an aspect ratio of 2:1 with minimum dimensions of 300x157 or maximum of 4096x4096 pixels. Images must be less than 5MB in size. JPG, PNG, WEBP and GIF formats are supported. Only the first frame of an animated GIF will be used. SVG is not supported. :image_alt - A text description of the image conveying the essential nature of an image to users who are visually impaired. Maximum 420 characters. :player - HTTPS URL of player iframe :player_width - Width of iframe in pixels :player_height - Height of iframe in pixels :player_stream - URL to raw video or audio stream :app_name_iphone - Name of your iPhone app :app_id_iphone - Your app ID in the iTunes App Store :app_url_iphone - Your app's custom URL scheme :app_name_ipad - Name of your iPad optimized app :app_id_ipad - Your app ID in the iTunes App Store :app_url_ipad - Your app's custom URL scheme :app_name_googleplay - Name of your Android app :app_id_googleplay - Your app ID in the Google Play Store :app_url_googleplay - Your app’s custom URL scheme :app_country - If your application is not available in the US App Store, you must set this value to the two-letter country code for the App Store that contains your application. If used alongside the OpenGraph tags, the Twitter tags will win when shared on Twitter. If not provided, Twitter will use the OpenGraph tags. Unless you have specific messaging for Twitter followers, it's typically good enough to use OpenGraph for most data.","ref":"SEO.Twitter.html#build/2","title":"SEO.Twitter.build/2","type":"function"},{"doc":"Attributes item ( SEO.Twitter ) - Defaults to nil . config ( :any ) - Defaults to nil .","ref":"SEO.Twitter.html#meta/1","title":"SEO.Twitter.meta/1","type":"function"},{"doc":"@username for the content creator / author","ref":"SEO.Twitter.html#t:creator/0","title":"SEO.Twitter.creator/0","type":"type"},{"doc":"","ref":"SEO.Twitter.html#t:pixels/0","title":"SEO.Twitter.pixels/0","type":"type"},{"doc":"@username for the website used in the card footer","ref":"SEO.Twitter.html#t:site/0","title":"SEO.Twitter.site/0","type":"type"},{"doc":"","ref":"SEO.Twitter.html#t:t/0","title":"SEO.Twitter.t/0","type":"type"},{"doc":"Some platforms (eg, Slack and Discord) have adopted an older and deprecated Twitter Product Card specification that allows for two arbitrary data points. For example, some blogs may include a reading time. Another example, if selling a product you may display a variation (eg, color is black) and also display the price (eg, price is $20). This module should be used alongside the SEO.OpenGraph module for completeness. For example, in the screenshot below, :label1 is &quot;Reading Time&quot; and :data1 is &quot;15 minutes&quot; , and :label2 is &quot;Published&quot; and :data2 is &quot;2020-01-19&quot; . Resources https://api.slack.com/reference/messaging/link-unfurling#classic_unfurl","ref":"SEO.Unfurl.html","title":"SEO.Unfurl","type":"module"},{"doc":"Arbitrary data points about your object. label1 and data1 both should be provided in order to render. Same with label2/data2. For example, label1 could be &quot;price&quot; and data1 could be &quot;$10&quot; . :label1 - Label describing data1 :data1 - 1st data point :label2 - Label describing data2 :data2 - 2nd data point","ref":"SEO.Unfurl.html#build/2","title":"SEO.Unfurl.build/2","type":"function"},{"doc":"Attributes item ( SEO.Unfurl ) (required) config ( :any ) - Defaults to nil .","ref":"SEO.Unfurl.html#meta/1","title":"SEO.Unfurl.meta/1","type":"function"},{"doc":"","ref":"SEO.Unfurl.html#t:t/0","title":"SEO.Unfurl.t/0","type":"type"},{"doc":"Metadata describing an article. Resources https://ogp.me/#type_article","ref":"SEO.OpenGraph.Article.html","title":"SEO.OpenGraph.Article","type":"module"},{"doc":"Build metadata about an article. :published_time - when the article was first published. :modified_time - when the article was last changed. :expiration_time - when the article is out of date after. :author - Writers of the article. This can be nested author OpenGraph metadata or URLs that provide the metadata or simply the author's name. :section - A high-level section name. E.g. &quot;Technology&quot; :tag - Tag words associated with this article. E.g. [&quot;Elixir&quot;, &quot;Ecto&quot;]","ref":"SEO.OpenGraph.Article.html#build/2","title":"SEO.OpenGraph.Article.build/2","type":"function"},{"doc":"Attributes content ( SEO.OpenGraph.Article ) - Defaults to nil .","ref":"SEO.OpenGraph.Article.html#meta/1","title":"SEO.OpenGraph.Article.meta/1","type":"function"},{"doc":"","ref":"SEO.OpenGraph.Article.html#t:t/0","title":"SEO.OpenGraph.Article.t/0","type":"type"},{"doc":"Data describing an audio file.","ref":"SEO.OpenGraph.Audio.html","title":"SEO.OpenGraph.Audio","type":"module"},{"doc":"The og:audio property has some optional structured properties: :url - The url with metadata that describes the audio. :secure_url - An alternate url to use if the webpage requires HTTPS. :type - A MIME type for this audio, eg, &quot;audio/mpeg&quot; .","ref":"SEO.OpenGraph.Audio.html#build/2","title":"SEO.OpenGraph.Audio.build/2","type":"function"},{"doc":"Attributes content ( :any ) (required)","ref":"SEO.OpenGraph.Audio.html#meta/1","title":"SEO.OpenGraph.Audio.meta/1","type":"function"},{"doc":"","ref":"SEO.OpenGraph.Audio.html#t:mime/0","title":"SEO.OpenGraph.Audio.mime/0","type":"type"},{"doc":"","ref":"SEO.OpenGraph.Audio.html#t:t/0","title":"SEO.OpenGraph.Audio.t/0","type":"type"},{"doc":"Metadata describing a book Resources https://ogp.me/#type_book","ref":"SEO.OpenGraph.Book.html","title":"SEO.OpenGraph.Book","type":"module"},{"doc":"Metadata that describes a book. :author - Who wrote this book. This may be a name or a URL that implements SEO.OpenGraph.Profile for the author with additional details. This may be supplied as a list of authors. :isbn - The ISBN :release_date - The date the book was released. :tag - Tag words associated with this book.","ref":"SEO.OpenGraph.Book.html#build/2","title":"SEO.OpenGraph.Book.build/2","type":"function"},{"doc":"Attributes content ( SEO.OpenGraph.Book ) (required)","ref":"SEO.OpenGraph.Book.html#meta/1","title":"SEO.OpenGraph.Book.meta/1","type":"function"},{"doc":"","ref":"SEO.OpenGraph.Book.html#t:t/0","title":"SEO.OpenGraph.Book.t/0","type":"type"},{"doc":"URL or details for the image. The og:image property has some optional structured properties: :url - Identical to og:image . :secure_url - An alternate url to use if the webpage requires HTTPS. :type - A MIME type for this image. :width - The number of pixels wide. :height - The number of pixels high. :alt - A description of what is in the image (not a caption). If the page specifies an image it should also specify :alt . NOTE : to update an image after it's been published, use a new URL for the new image. Images are typically cached based on the URL and won't be updated unless the URL changes. In Phoenix, the URL is typically using a hashed version of the image (see mix phx.digest ), so this should be handled automatically. Best practices: Use images that are at least 1080 pixels in width for best display on high resolution devices. At the minimum, you should use images that are 600 pixels in width to display image link ads. We recommend using 1:1 images in your ad creatives for better performance with image link ads. Pre-cache your images by running the URL through the URL Sharing Debugger tool to pre-fetch metadata for the website. You should also do this if you update the image for a piece of content. Use :width and :height to specify the image dimensions to the crawler so that it can render the image immediately without having to asynchronously download and process it. Resources https://ogp.me/#structured https://developers.facebook.com/docs/sharing/best-practices#images","ref":"SEO.OpenGraph.Image.html","title":"SEO.OpenGraph.Image","type":"module"},{"doc":"","ref":"SEO.OpenGraph.Image.html#build/2","title":"SEO.OpenGraph.Image.build/2","type":"function"},{"doc":"Attributes content ( :any ) - Either an SEO.OpenGraph.Image , a string, or a URI. Defaults to nil .","ref":"SEO.OpenGraph.Image.html#meta/1","title":"SEO.OpenGraph.Image.meta/1","type":"function"},{"doc":"","ref":"SEO.OpenGraph.Image.html#t:mime/0","title":"SEO.OpenGraph.Image.mime/0","type":"type"},{"doc":"","ref":"SEO.OpenGraph.Image.html#t:pixels/0","title":"SEO.OpenGraph.Image.pixels/0","type":"type"},{"doc":"","ref":"SEO.OpenGraph.Image.html#t:t/0","title":"SEO.OpenGraph.Image.t/0","type":"type"},{"doc":"Resources https://ogp.me/#type_profile","ref":"SEO.OpenGraph.Profile.html","title":"SEO.OpenGraph.Profile","type":"module"},{"doc":"Build a OpenGraph Profile :first_name - A name normally given to an individual by a parent or self-chosen. :last_name - A name inherited from a family or marriage and by which the individual is commonly known. :username - A short unique string to identify them. :gender - Their gender.","ref":"SEO.OpenGraph.Profile.html#build/2","title":"SEO.OpenGraph.Profile.build/2","type":"function"},{"doc":"Attributes content ( :any ) (required) property ( :string ) - Defaults to &quot;profile&quot; .","ref":"SEO.OpenGraph.Profile.html#meta/1","title":"SEO.OpenGraph.Profile.meta/1","type":"function"},{"doc":"","ref":"SEO.OpenGraph.Profile.html#t:t/0","title":"SEO.OpenGraph.Profile.t/0","type":"type"},{"doc":"Data describing a video. Commonly, an og:video is accompanied with an og:image that provides the preview image for the video. Resources https://ogp.me/#structured https://developers.facebook.com/docs/sharing/webmasters/#video https://yandex.com/support/video/partners/open-graph.html","ref":"SEO.OpenGraph.Video.html","title":"SEO.OpenGraph.Video","type":"module"},{"doc":"The og:video property has some optional structured properties: :url - The url with metadata that describes the video. :secure_url - An alternate url to use if the webpage requires HTTPS. If the URL starts with https then :type - A MIME type for this video. Facebook supports both mp4 and Flash videos, application/x-shockwave-flash or video/mp4 , but please for the love of all that is holy don't use Shockwave Flash. :width - The width in pixels. :height - The height in pixels. :alt - A description of what is in the video (not a caption). If the page specifies an og:video it should specify og:video:alt . Supply a secure URL for both the og:video:url and og:video:secure_url tags to make your video eligible to play in-line in Facebook's Feed. For Yandex, there are additional properties: :ya_bitrate - Maximum bitrate in kilobits per second :ya_allow_embed - Allow embedding in Yandex search results :ya_quality - The quality in resolution and bitrate :low - Low quality with resolution less than 360x640 and bitrate lower than 717kbps :medium - Average quality with resolution between 360x640 and 720x1280 and bitrate between than 717kbps-1Mbps :hd - HD quality with resolution between 720x1280 and 1080x1920 and bitrate between than 1MBps-2Mbps :full_hd - 1080p quality with resolution greater than 1080x1920 and bitrate higher than 2Mbps","ref":"SEO.OpenGraph.Video.html#build/2","title":"SEO.OpenGraph.Video.build/2","type":"function"},{"doc":"Attributes content ( :any ) (required)","ref":"SEO.OpenGraph.Video.html#meta/1","title":"SEO.OpenGraph.Video.meta/1","type":"function"},{"doc":"","ref":"SEO.OpenGraph.Video.html#t:mime/0","title":"SEO.OpenGraph.Video.mime/0","type":"type"},{"doc":"","ref":"SEO.OpenGraph.Video.html#t:pixels/0","title":"SEO.OpenGraph.Video.pixels/0","type":"type"},{"doc":"","ref":"SEO.OpenGraph.Video.html#t:t/0","title":"SEO.OpenGraph.Video.t/0","type":"type"},{"doc":"","ref":"SEO.OpenGraph.Video.html#t:yandex_bitrate/0","title":"SEO.OpenGraph.Video.yandex_bitrate/0","type":"type"},{"doc":"","ref":"SEO.OpenGraph.Video.html#t:yandex_quality/0","title":"SEO.OpenGraph.Video.yandex_quality/0","type":"type"},{"doc":"A SEO.Breadcrumb.List is list of items consisting of a chain of linked Web pages, typically described using at least their URL and their name, and typically ending with the current page. The :position property is used to reconstruct the order of the items in a SEO.Breadcrumb.List . The convention is that a breadcrumb list has an itemListOrder of ItemListOrderAscending (lower values listed first), and that the first items in this list correspond to the &quot;top&quot; or beginning of the breadcrumb trail, e.g. with a site or section homepage. The specific values of 'position' are not assigned meaning for a BreadcrumbList, but they should be integers, e.g. beginning with '1' for the first item in the list.","ref":"SEO.Breadcrumb.List.html","title":"SEO.Breadcrumb.List","type":"module"},{"doc":"Build a list of items that represent breadcrumbs for your item. You may build the list with SEO.Breadcrumb.ListItem or with attributes that will build a ListItem. The position will be inferred from the list provided, but if you need to supply the position manually, you must supply SEO.Breadcrumb.ListItem . For example: SEO.Breadcrumb.List . build ( [ %{ name : &quot;Posts&quot; , item : Routes . blog_url ( @endpoint , :index ) } , %{ name : &quot;My Post&quot; , item : Routes . blog_url ( @endpoint , :show , my_id ) } ] )","ref":"SEO.Breadcrumb.List.html#build/2","title":"SEO.Breadcrumb.List.build/2","type":"function"},{"doc":"","ref":"SEO.Breadcrumb.List.html#t:t/0","title":"SEO.Breadcrumb.List.t/0","type":"type"},{"doc":"One item in a SEO.Breadcrumb.List","ref":"SEO.Breadcrumb.ListItem.html","title":"SEO.Breadcrumb.ListItem","type":"module"},{"doc":"","ref":"SEO.Breadcrumb.ListItem.html#build/2","title":"SEO.Breadcrumb.ListItem.build/2","type":"function"},{"doc":"","ref":"SEO.Breadcrumb.ListItem.html#t:t/0","title":"SEO.Breadcrumb.ListItem.t/0","type":"type"},{"doc":"","ref":"SEO.Breadcrumb.Build.html","title":"SEO.Breadcrumb.Build","type":"protocol"},{"doc":"","ref":"SEO.Breadcrumb.Build.html#build/1","title":"SEO.Breadcrumb.Build.build/1","type":"function"},{"doc":"","ref":"SEO.Breadcrumb.Build.html#t:t/0","title":"SEO.Breadcrumb.Build.t/0","type":"type"},{"doc":"","ref":"SEO.Facebook.Build.html","title":"SEO.Facebook.Build","type":"protocol"},{"doc":"","ref":"SEO.Facebook.Build.html#build/1","title":"SEO.Facebook.Build.build/1","type":"function"},{"doc":"","ref":"SEO.Facebook.Build.html#t:t/0","title":"SEO.Facebook.Build.t/0","type":"type"},{"doc":"","ref":"SEO.OpenGraph.Build.html","title":"SEO.OpenGraph.Build","type":"protocol"},{"doc":"","ref":"SEO.OpenGraph.Build.html#build/1","title":"SEO.OpenGraph.Build.build/1","type":"function"},{"doc":"","ref":"SEO.OpenGraph.Build.html#t:t/0","title":"SEO.OpenGraph.Build.t/0","type":"type"},{"doc":"","ref":"SEO.Site.Build.html","title":"SEO.Site.Build","type":"protocol"},{"doc":"","ref":"SEO.Site.Build.html#build/1","title":"SEO.Site.Build.build/1","type":"function"},{"doc":"","ref":"SEO.Site.Build.html#t:t/0","title":"SEO.Site.Build.t/0","type":"type"},{"doc":"","ref":"SEO.Twitter.Build.html","title":"SEO.Twitter.Build","type":"protocol"},{"doc":"","ref":"SEO.Twitter.Build.html#build/1","title":"SEO.Twitter.Build.build/1","type":"function"},{"doc":"","ref":"SEO.Twitter.Build.html#t:t/0","title":"SEO.Twitter.Build.t/0","type":"type"},{"doc":"","ref":"SEO.Unfurl.Build.html","title":"SEO.Unfurl.Build","type":"protocol"},{"doc":"","ref":"SEO.Unfurl.Build.html#build/1","title":"SEO.Unfurl.Build.build/1","type":"function"},{"doc":"","ref":"SEO.Unfurl.Build.html#t:t/0","title":"SEO.Unfurl.Build.t/0","type":"type"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Rework implementation.","ref":"changelog.html#0-1-1-october-14-2022","title":"Changelog - 0.1.1 (October 14, 2022)","type":"extras"},{"doc":"Initial release","ref":"changelog.html#0-1-0-october-13-2022","title":"Changelog - 0.1.0 (October 13, 2022)","type":"extras"},{"doc":"Copyright 2022 David Bernheisel Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]